import win32.windows;
import win32.windef;
import win32.commctrl;
import win32frame.WindowObject;
import win32frame.Panel;
import win32frame.CheckBox;
import win32frame.RadioButton;
import win32frame.PushButton;
import win32frame.StaticControl;
import win32frame.WindowMenu;
import win32frame.StatusBar;
import win32frame.ToolTip;
import win32frame.ComboBox;
import win32frame.Split;

import std.stdio;
import std.string;
import std.utf;

import util.Image;

import TestDialog;
import OpenGLFrameTest;
import GraphicFrameTest;
import SliderBase ;
import SliderGrad ;
import MyButton ;
import Spin;
import ProgressWindow;

ushort LOWORD(uint l){ return l & 0xffff; }
ushort HIWORD(uint l){ return l >>> 16; }

enum CMD{
  NON    = 0x0ff,
  MYBTN  = 0x100,
  PROGRES= 0x101,
  GDISP  = 0x102,
  SLIDE  = 0x103,
  SLIDEG = 0x104,
  SPIN   = 0x105
} ;

class SubPanel2 : WindowObject {
  Split         split1   ;
  Split         split2   ;
  Panel         panel    ;
  PushButton    button1  ;
  PushButton    button2  ;
  SliderBase    slider   ;
  SliderGrad    sliderG  ;
  Spin          spin     ;
  MyButton      mybutton ;
  ToolTip       tooltip  ;
  OpenGLFrameTest  opengl  ;
  GraphicFrameTest graphic ;

  HFONT hFont,hfont;

  int showStrctl=0 ;

  this(string name, string ClassName) {
    winc.style          = 0; //CS_HREDRAW | CS_VREDRAW;
    winc.cbClsExtra     = 0;
    winc.cbWndExtra     = 0;
    winc.hIcon          = LoadIcon(null , cast(wchar*)(IDI_APPLICATION));
    winc.hCursor        = LoadCursor(null , cast(wchar*)(IDC_ARROW));
    winc.hbrBackground  = CreateSolidBrush(GetSysColor(COLOR_BTNFACE)) ;
    winc.lpszMenuName   = null;
    winc.lpszClassName  = cast(wchar*)(ClassName) ;
    super(name) ;
    this.registwinc() ;
  }

  LRESULT proc(HWND hwnd , UINT msg , WPARAM wp , LPARAM lp){
    switch (msg) {
    case WM_DESTROY:
      DeleteObject(hFont);
      DeleteObject(hfont);
      break ;
      
    case WM_CREATE:
      
      hFont = CreateFont(
			 14 , 0 , 0 , 0 , FW_REGULAR , FALSE , FALSE , FALSE ,
			 SHIFTJIS_CHARSET , OUT_DEFAULT_PRECIS ,
			 CLIP_DEFAULT_PRECIS , DEFAULT_QUALITY , 
			 VARIABLE_PITCH, null
			 );
      
      hfont = CreateFont(
                         12 , 0 , 0 , 0 , FW_REGULAR , FALSE , FALSE , FALSE ,
                         SHIFTJIS_CHARSET , OUT_DEFAULT_PRECIS ,
                         CLIP_DEFAULT_PRECIS , DEFAULT_QUALITY , 
                         FIXED_PITCH, null
                         );
      
      
      split1 = new Split("Split1",1) ;
      split1.setStyle( WS_CHILD |WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_VISIBLE ) ; //| WS_THICKFRAME ) ;
      split1.setPosition(300,128,256,256) ;
      split1.setSashPos(100,50,150) ;
      addObject( split1, cast(HMENU)(CMD.NON),true, true) ;
      
      panel = new Panel("Panel1") ;
      panel.setStyle( WS_CHILD |WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_VISIBLE ) ;
      panel.setPosition(0,0,300,200) ;
      split1.addObject( panel, cast(HMENU)(CMD.NON) ) ;

      button1= new PushButton("Progress") ;
      button1.setPosition(0,0,100,20) ;
      panel.addObject(button1, cast(HMENU)(CMD.PROGRES)) ;
      button1.setFont(hFont) ;

      button2= new PushButton("HIDE") ;
      button2.setPosition(100,0,100,20) ;
      panel.addObject(button2, cast(HMENU)(CMD.GDISP)) ;
      button2.setFont(hFont) ;

      mybutton = new MyButton("MyButton") ;
      mybutton.setPosition(200,0,100,20) ;
      panel.addObject(mybutton, cast(HMENU)(CMD.MYBTN), false, false) ;
      mybutton.setFont(hFont) ;
      tooltip=new ToolTip() ;
      tooltip.setText("自作ボタン") ;
      mybutton.addToolTip( tooltip ) ;
      tooltip.setClientRect() ;

      slider = new SliderBase("Slider","SliderTest") ;
      slider.addExStyle(WS_EX_CLIENTEDGE) ;
      slider.setStyle(WS_CHILD |WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_VISIBLE) ;
      slider.setPosition(0,20,256,20) ;
      slider.setInfo(0, 0.0,360.0,180.0) ;
      slider.setBGcolor(0,0,255,0) ;
      slider.setFGcolor(255,0,0,0) ;
      panel.addObject(slider, cast(HMENU)(CMD.SLIDE), true, false) ;
      tooltip=new ToolTip() ;
      tooltip.setText("Slider") ;
      slider.addToolTip( tooltip ) ;
      tooltip.setClientRect() ;
      
      sliderG = new SliderGrad("Sliderg","SliderTestG") ;
      sliderG.addExStyle(WS_EX_CLIENTEDGE) ;
      sliderG.setStyle(WS_CHILD |WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_VISIBLE) ;
      sliderG.setPosition(0,40,256,20) ;
      sliderG.setInfo(0, 0.0,100.0,50.0) ;
      sliderG.setBGcolor(255,0,0,255) ;
      sliderG.setFGcolor(255,0,0,0) ;
      panel.addObject(sliderG, cast(HMENU)(CMD.SLIDEG), true, false) ;

      spin = new Spin("Spin", "Spin") ;
      spin.setStyle( WS_CHILD |WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_VISIBLE ) ;
      spin.setPosition(0,60,300,20) ;
      spin.setTextFormat("%.3f") ;
      spin.setInfo( 0, 0, 100, 1 ) ;
      panel.addObject(spin, cast(HMENU)(CMD.SPIN), true, false) ;
      spin.setTextFont(hfont) ;

      split2 = new Split("Split2") ;
      split2.setStyle( WS_CHILD |WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_VISIBLE) ;
      split2.setPosition(500,100,256,256) ;
      split1.addObject(split2, cast(HMENU)(CMD.NON)) ;

      graphic = new GraphicFrameTest("GraphicFrame", "GraphicFrameTest") ;
      graphic.setPosition(0, 460,256,256) ;
      graphic.setStyle( WS_CHILD |WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_VISIBLE ) ;
      split2.addObject(graphic, cast(HMENU)(CMD.NON)) ;
      
      opengl = new OpenGLFrameTest("OpenGLFrame", "OpenGLFrameTest") ;
      opengl.setPosition(0,0,640,480) ;
      opengl.setStyle(WS_CHILD |WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_VISIBLE) ;
      split2.addObject(opengl, cast(HMENU)(CMD.NON)) ;
      
      break ;
      
    case WM_PAINT:
      PAINTSTRUCT ps;
      HDC hdc;
      hdc = BeginPaint(hwnd, &ps);
      EndPaint(hwnd, &ps);
      break ;
      
    case WM_MOVE:
      break ;
      
    case WM_SIZE:
      break;
      
    case WM_LBUTTONDOWN:
    case WM_LBUTTONUP:
    case WM_LBUTTONDBLCLK:
    case WM_RBUTTONDOWN:
    case WM_RBUTTONUP:
    case WM_RBUTTONDBLCLK:
    case WM_MOUSEMOVE:
      break ;

    case WM_COMMAND:
      switch( LOWORD(wp) ){
      case CMD.PROGRES:
	RECT wrect ;
	GetWindowRect(hwnd,&wrect) ;
        ProgressWindow progresswin ;
        progresswin = new ProgressWindow("ProgressWindow") ;
        progresswin.start(wrect.left,wrect.top+100,400,100) ;	
	for( int i=0 ; i<100 ; i++ ){
	  for( int j=0 ; j<20000000 ; j++ ){
	    if( j==0 ) progresswin.setRate(i+1) ;
	  }
	}
        progresswin.close() ;	
	break ;
      case CMD.GDISP:
	if( showStrctl==0 ){
	  split2.hide() ;
	  button2.setWindowText("SHOW") ;
	  printStatusbar("消された") ;
	}else{
	  split2.show() ;
	  button2.setWindowText("HIDE") ;
	  printStatusbar("表示された") ;
	}
	showStrctl = (showStrctl + 1) % 2 ;
	break ;
	
      case CMD.SLIDE :
	printStatusbar(format("Slider=%d",cast(int)(slider.getValue()))) ;
      	break ;
	
      case CMD.SLIDEG :
	printStatusbar(format("GradSlider=%d",cast(int)(sliderG.getValue()))) ;
      	break ;
	
      default :	break ;
      }
      break;
      
    default :
      return( DefWindowProc(hwnd , msg , wp , lp) );
    }
    return(0);
  }

  int LoadImage(string fname){
    int   ret=-1 ;
    Image image = new Image() ;
    if( image.open(fname)<0 ){
      ret=-1 ;
    }else{
      if( graphic !is null ){
	graphic.setImageSize(image.getWidth(),image.getHeight()) ;
	uint *imgbuf=graphic.getImageBuffer() ;
	int   imgw=image.getWidth()  ;
	int   imgh=image.getHeight() ;
	for( int i=0 ; i<imgh ; i++ ){
	  uint[] img = image.readline(1,true) ;
	  imgbuf[imgw*i .. imgw*i+imgw] = img[0..$] ;
	  delete img ;
	}
	graphic.reDisplay() ;
	ret=0 ;
      }
    }
    image.close() ;
    delete image ;
    return(ret) ;
  }
}
