import win32.windows;
import win32.windef;
import win32.commctrl;
import win32frame.DialogBoxClass;
import win32frame.CheckBox;
import win32frame.PushButton;
import std.stdio;
import std.string;

ushort LOWORD(uint l){ return l & 0xffff; }

enum CMD{
  OK     = 0x100,
  CANCEL = 0x101,
  CHECK  = 0x201
} ;

class TestDialog : DialogBoxClass {
  PushButton  btnok  ;
  PushButton  btncan ;
  CheckBox    chkbox ;
  HFONT       hfont  ;

  int         dlgstate ;
  int         chkstate ;

  this(string name, string ClassName) {
    UnregisterClass( cast(wchar*)(ClassName), GetModuleHandle(null) ) ;
    winc.cbSize         = WNDCLASSEX.sizeof;
    winc.style          = 0; //CS_HREDRAW | CS_VREDRAW ;
    winc.cbClsExtra     = 0;
    winc.cbWndExtra     = 0;
    winc.hIcon          = LoadIcon(null , cast(wchar*)(IDI_APPLICATION));
    winc.hCursor        = LoadCursor(null , cast(wchar*)(IDC_ARROW));
    winc.hbrBackground  = CreateSolidBrush(GetSysColor(COLOR_BTNFACE)) ;
    winc.lpszMenuName   = null;
    winc.lpszClassName  = cast(wchar*)(ClassName) ;
    super(name) ;
  }
  
  LRESULT proc(HWND hwnd , UINT msg , WPARAM wp , LPARAM lp){
    switch (msg) {
    case WM_DESTROY:
      DeleteObject(hfont);
      break ;
    case WM_CREATE:
      hfont = CreateFont(
			 12 , 0 , 0 , 0 , FW_REGULAR , FALSE , FALSE , FALSE ,
			 SHIFTJIS_CHARSET , OUT_DEFAULT_PRECIS ,
			 CLIP_DEFAULT_PRECIS , DEFAULT_QUALITY , 
			 FIXED_PITCH, null
			 );
      
      btnok= new PushButton("OK") ;
      btnok.setPosition(0,0,100,20) ;
      addObject( btnok, cast(HMENU)(CMD.OK) ) ;
      btnok.setFont(hfont) ;

      btncan= new PushButton("Cancel") ;
      btncan.setPosition(0,20,100,20) ;
      addObject( btncan, cast(HMENU)(CMD.CANCEL) ) ;
      btncan.setFont(hfont) ;
      
      chkbox  = new CheckBox("Check") ;
      chkbox.setPosition(0,40,100,20) ;
      chkbox.addStyle(BS_AUTOCHECKBOX) ;
      addObject( chkbox, cast(HMENU)(CMD.CHECK) ) ;
      chkbox.setFont(hfont) ;
      chkstate=0 ;
      
      dlgstate=CMD.CANCEL ;
      break ;
      
    case WM_PAINT:
      PAINTSTRUCT ps;
      HDC hdc;
      hdc = BeginPaint(hwnd, &ps);
      SetBkMode(hdc,TRANSPARENT) ;
      SelectObject(hdc , hfont);
      TextOut(hdc , 8 , 60 , cast(wchar*)("ダイアログテスト") , 8);
      SelectObject(hdc , GetStockObject(SYSTEM_FONT));
      EndPaint(hwnd, &ps);
      break ;
      
    case WM_SIZE:
      break ;
      
    case WM_CLOSE:
      setResult(dlgstate) ;
      DestroyWindow(hwnd);
      break ;
      
    case WM_COMMAND:
      dlgstate=LOWORD(wp) ;
      switch( dlgstate ){
      case CMD.OK :
      case CMD.CANCEL :
	setResult(dlgstate) ;
	DestroyWindow(hwnd);
	break ;
      case CMD.CHECK :
	chkstate=chkbox.getState() ;
	break ;
      default :
	break ;
      }
      break ;
      
    default :
      return( DefWindowProc(hwnd , msg , wp , lp) );
    }
    return(0);
  }

  int getCheckState(){
    return(chkstate) ;
  }
}
  
