import win32.windows;
import win32.windef;
import win32.commctrl;
import win32frame.Frame;
import win32frame.WindowMenu;
import win32frame.StatusBar;
import win32frame.ToolBarEx;
import win32frame.Rebar;
import win32frame.PushButton;
import win32frame.MainWindow ;
import win32frame.MsgBox;
import win32frame.FileDialog;

import TestDialog;
import OpenGLFrameTest;
import GraphicFrameTest;
import SliderBase ;
import MyButton ;
import MainPanel ;
import std.stdio;
import std.string;
import std.utf;

ushort LOWORD(uint l){ return l & 0xffff; }
ushort HIWORD(uint l){ return l >>> 16; }

enum FILE{
  ROOT  =0x100,
  OPEN  =0x101,
  CLOSE =0x102,
  EXIT  =0x103
} ;
enum EDIT{
  ROOT  =0x200,
  CUT   =0x201,
  COPY  =0x202,
  PASTE =0x203
} ;

enum CMD{
  OPENDLG =0xa00,
} ;

enum TOOLBAR{
  ROOT    =0x500,
  NEWFILE =0x501,
  FOPEN   =0x502,
  FSAVE   =0x503,
  FCOPY   =0x504,
  ECUT    =0x505,
  EDEL    =0x506
} ;
  

class myMainWindow : MainWindow {
  WindowMenu  menuroot ;
  TestDialog  dlogbox ;
  StatusBar   statusbar ;
  ToolBarEx   toolbarex ;
  TBBUTTON[]  tbButton ;
  MainPanel   mainpanel ;
  PushButton  button ;
  
  HFONT hFont;

  this(string name, string ClassName) {
    winc.style          = 0; //CS_HREDRAW | CS_VREDRAW;
    winc.cbClsExtra     = 0;
    winc.cbWndExtra     = 0;
    winc.hIcon          = LoadIcon(null , cast(wchar*)(IDI_APPLICATION));
    winc.hCursor        = LoadCursor(null , cast(wchar*)(IDC_ARROW));
    winc.hbrBackground  = CreateSolidBrush(GetSysColor(COLOR_BTNFACE)) ;
    winc.lpszMenuName   = null;
    winc.lpszClassName  = cast(wchar*)(ClassName) ;
    super(name,ClassName) ;
    
    tbButton.length = 7 ;
    tbButton[0].iBitmap=STD_FILENEW  ; tbButton[0].idCommand=TOOLBAR.NEWFILE ; tbButton[0].fsState=TBSTATE_ENABLED ; tbButton[0].fsStyle=TBSTYLE_BUTTON ;
    tbButton[1].iBitmap=STD_FILEOPEN ; tbButton[1].idCommand=TOOLBAR.FOPEN   ; tbButton[1].fsState=TBSTATE_ENABLED ; tbButton[1].fsStyle=TBSTYLE_BUTTON ;
    tbButton[2].iBitmap=STD_FILESAVE ; tbButton[2].idCommand=TOOLBAR.FSAVE   ; tbButton[2].fsState=TBSTATE_ENABLED ; tbButton[2].fsStyle=TBSTYLE_BUTTON ;
    tbButton[3].iBitmap=0            ; tbButton[3].idCommand=0               ; tbButton[3].fsState=TBSTATE_ENABLED ; tbButton[3].fsStyle=TBSTYLE_SEP    ;
    tbButton[4].iBitmap=STD_COPY     ; tbButton[4].idCommand=TOOLBAR.FCOPY   ; tbButton[4].fsState=TBSTATE_ENABLED ; tbButton[4].fsStyle=TBSTYLE_BUTTON ;
    tbButton[5].iBitmap=STD_CUT      ; tbButton[5].idCommand=TOOLBAR.ECUT    ; tbButton[5].fsState=TBSTATE_ENABLED ; tbButton[5].fsStyle=TBSTYLE_BUTTON ;
    tbButton[6].iBitmap=STD_DELETE   ; tbButton[6].idCommand=TOOLBAR.EDEL    ; tbButton[6].fsState=TBSTATE_ENABLED ; tbButton[6].fsStyle=TBSTYLE_BUTTON ;
  }

  LRESULT proc(HWND hwnd , UINT msg , WPARAM wp , LPARAM lp){
    switch (msg) {
    case WM_DESTROY:
      DeleteObject(hFont);
      PostQuitMessage(0);
      break ;
      
    case WM_CREATE:
      menuroot = new WindowMenu() ;
      menuroot.create() ;
      menuroot.addMenu(             MFT_STRING, "File"     , FILE.ROOT ) ;
      menuroot.addItem( "File",     MFT_STRING, "Open"     , FILE.OPEN ) ;
      menuroot.addItem( "File",     MFT_STRING, "Close"    , FILE.CLOSE) ;
      menuroot.addItem( "File",     MFT_STRING, "Exit"     , FILE.EXIT ) ;
      menuroot.addMenu(             MFT_STRING, "Edit"     , EDIT.ROOT ) ;
      menuroot.addItem( "Edit",     MFT_STRING, "Cut"      , EDIT.CUT  ) ;
      menuroot.addItem( "Edit",     MFT_STRING, "Copy"     , EDIT.COPY ) ;
      menuroot.addItem( "Edit",     MFT_STRING, "Paste"    , EDIT.PASTE) ;
      
      setMenu(menuroot) ;
      
      statusbar = new StatusBar() ;
      statusbar.addStyle(CCS_BOTTOM | SBARS_SIZEGRIP) ;
      addStatusBar(statusbar, "") ;
      
      hFont = CreateFont(
			 14 , 0 , 0 , 0 , FW_REGULAR , FALSE , FALSE , FALSE ,
			 SHIFTJIS_CHARSET , OUT_DEFAULT_PRECIS ,
			 CLIP_DEFAULT_PRECIS , DEFAULT_QUALITY , 
			 VARIABLE_PITCH, null
			 );
      
      toolbarex = new ToolBarEx() ;
      toolbarex.addStyle(CCS_ADJUSTABLE|TBSTYLE_FLAT|CCS_NOPARENTALIGN|CCS_NORESIZE|CCS_NODIVIDER) ;
      toolbarex.create(hwnd, TOOLBAR.ROOT, 0, tbButton, tbButton.length) ;
      addonRebar(toolbarex) ;

      button= new PushButton("OpenDialog") ;
      button.setPosition(0,20,100,20) ;
      addObject(button, cast(HMENU)(CMD.OPENDLG)) ;
      addonRebar(button) ;
      button.setFont(hFont) ;
      
      mainpanel = new MainPanel("MainPanel","MainPanelTest") ;
      mainpanel.setPosition(0,0,200,200) ;
      mainpanel.setStyle( WS_CHILD |WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_VISIBLE ) ;
      addObject( mainpanel, null, true, true ) ;
      
      break ;
      
    case WM_MOVE:
      break ;
      
    case WM_SIZE:
      break;
      
    case WM_LBUTTONDOWN:
    case WM_LBUTTONUP:
    case WM_LBUTTONDBLCLK:
    case WM_RBUTTONDOWN:
    case WM_RBUTTONUP:
    case WM_RBUTTONDBLCLK:
    case WM_MOUSEMOVE:
      break ;

    case WM_COMMAND:
      switch( LOWORD(wp) ){
      case TOOLBAR.FOPEN :
      case FILE.OPEN :
	FileDialog fdlog = new FileDialog() ;
	string     fname = fdlog.getLoadFileName("JPEG {*.JPG}\0*.jpg\0PNG {*.PNG}\0*.png\0",hwnd) ;
	writef("fname=%s\n",fname) ;
        if( fname.length!=0 ){
          if( this.mainpanel.subpanel2.LoadImage(fname)==0 ){
	    printStatusbar( format("%sを開きました",fname) ) ;
	  }
	}
	break ;
      
      case FILE.EXIT :
	int    msgbox_ret ;
	MsgBox msgbox ;
	msgbox = new MsgBox(hwnd, "終了しますか？", "確認", MB_YESNO ) ;
	msgbox_ret = msgbox.create() ;
	if( msgbox_ret==IDYES ){
	  SendMessage(hwnd, WM_CLOSE, 0,0) ;
	}
	break ;
	
      case CMD.OPENDLG :
	dlogbox = new TestDialog("Dialog", "DialogBox") ;
	dlogbox.create( WS_DLGFRAME | WS_SYSMENU | WS_VISIBLE,
			winX+100, winY+100, 200, 200, hwnd, null ) ;
	int dlgret = dlogbox.getDlogResult() ;
	int chkret = dlogbox.getCheckState() ;
	printStatusbar( format("dlog_result=%d / CheckState=%d",dlgret,chkret) ) ;
	delete dlogbox ;
	break ;

      case TOOLBAR.NEWFILE :
	printStatusbar( "ToolBar NewFile" ) ;
	break ;

      default :
	writef("%d\n",wp) ;
	break ;
      }
      break;
      
    default :
      return( DefWindowProc(hwnd , msg , wp , lp) );
    }
    return(0);
  }
}
